Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionUtils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionUtils.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionUtils.java	(revision 44533)
@@ -62,26 +62,26 @@
         return expression;
     }
 
-    public static Expression createExpression(String phrase, String code, Script... scripts) {
-        Expression expression = ExpressionEvaluatorLocator.getManager().createExpression();
-        expression.setPhrase(phrase);
-        expression.setUserScript(code);
-        for (Script script : scripts) {
-            expression.addScript(script);
-        }
-        return expression;
-    }
+//    public static Expression createExpression(String phrase, String code, Script... scripts) {
+//        Expression expression = ExpressionEvaluatorLocator.getManager().createExpression();
+//        expression.setPhrase(phrase);
+//        expression.setUserScript(code);
+//        for (Script script : scripts) {
+//            expression.addScript(script);
+//        }
+//        return expression;
+//    }
+//
+//    public static Expression createExpression(String phrase, String code, String languaje, Script... scripts) {
+//        Expression expression = ExpressionEvaluatorLocator.getManager().createExpression();
+//        expression.setPhrase(phrase);
+//        expression.setUserScript(code, languaje);
+//        for (Script script : scripts) {
+//            expression.addScript(script);
+//        }
+//        return expression;
+//    }
 
-    public static Expression createExpression(String phrase, String code, String languaje, Script... scripts) {
-        Expression expression = ExpressionEvaluatorLocator.getManager().createExpression();
-        expression.setPhrase(phrase);
-        expression.setUserScript(code, languaje);
-        for (Script script : scripts) {
-            expression.addScript(script);
-        }
-        return expression;
-    }
-
     public static ExpressionBuilder createExpressionBuilder() {
         ExpressionBuilder builder = ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
         return builder;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/MutableSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/MutableSymbolTable.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/MutableSymbolTable.java	(revision 44533)
@@ -10,13 +10,13 @@
     
     public void addFunction(Function function);
     
-    public void addScript(Script script);
+//    public void addScript(Script script);
     
     public void addFunctions(Collection<Function> functions);
 
     public void removeVar(String name);
     
-    public void removeScript(Script script);
+//    public void removeScript(Script script);
     
     public void removeFunction(String name);
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Expression.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Expression.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Expression.java	(revision 44533)
@@ -25,22 +25,22 @@
     
     public String getPhrase();
     
-    public Script getUserScript(); 
-    
-    public UnmodifiableBasicList<Script> getScripts();
+//    public Script getUserScript(); 
+//    
+//    public UnmodifiableBasicList<Script> getScripts();
 
     public Expression setPhrase(String phrase);
     
-    public Expression setUserScript(String code, String languaje);
+//    public Expression setUserScript(String code, String languaje);
+//    
+//    public Expression setUserScript(String code);
+//    
+//    public Expression setUserScript(Script script);
+//    
+//    public void removeAllScripts();
+//    
+//    public Expression addScript(Script script);
     
-    public Expression setUserScript(String code);
-    
-    public Expression setUserScript(Script script);
-    
-    public void removeAllScripts();
-    
-    public Expression addScript(Script script);
-    
     public Object execute(SymbolTable symbolTable);
     
     public void link(SymbolTable symbolTable);    
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 44533)
@@ -76,6 +76,8 @@
 
     public Rule require_identifier(String id);
 
+    public Rule require_literal_string(String id);
+
     public Rule set_expression(String id, Object value);
 
     public Rule require_expression(String id);
@@ -84,8 +86,10 @@
 
     public ConditionalRule optional_any_token(String... id);
 
-    public Rule optional_identifiers(String id, String separator);
-
+    public ConditionalRule optional_identifiers(String id, String separator);
+    
+    public ConditionalRule optional_literal_string(String id);
+        
     public ArgsBuilder args_names(String... args);
     
     public ArgsBuilder args_expand(String... args);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractSymbolTable.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/spi/AbstractSymbolTable.java	(revision 44533)
@@ -9,12 +9,9 @@
 import java.util.List;
 import java.util.Map;
 import java.util.Set;
-import org.apache.commons.lang3.Range;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.Function;
-import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.SymbolTable;
-import org.gvsig.tools.script.Script;
 
 /**
  *
@@ -24,32 +21,32 @@
 
     private final String name;
 
-    public class ScriptFunction extends AbstractFunction {
+//    public class ScriptFunction extends AbstractFunction {
+//
+//        public ScriptFunction(String funcName) {
+//            super("Script", funcName, Range.between(1, Integer.MAX_VALUE));
+//        }
+//
+//        @Override
+//        public Object call(Interpreter interpreter, Object[] args) throws Exception {
+//            for (Script script : scripts()) {
+//                try {
+//                    return script.invokeFunction(this.name(), args);
+//                } catch (NoSuchMethodException ex) {
+//                    // Si la funcion no existe en el script pasamos al siguiente
+//                    // script.
+//                }
+//            }
+//            throw new NoSuchMethodException("Can't locate funcion '" + this.name() + "'.");
+//        }
+//
+//    }
 
-        public ScriptFunction(String funcName) {
-            super("Script", funcName, Range.between(1, Integer.MAX_VALUE));
-        }
-
-        @Override
-        public Object call(Interpreter interpreter, Object[] args) throws Exception {
-            for (Script script : scripts()) {
-                try {
-                    return script.invokeFunction(this.name(), args);
-                } catch (NoSuchMethodException ex) {
-                    // Si la funcion no existe en el script pasamos al siguiente
-                    // script.
-                }
-            }
-            throw new NoSuchMethodException("Can't locate funcion '" + this.name() + "'.");
-        }
-
-    }
-
     protected final List<SymbolTable> symbolTables;
     protected Map<String, Object> vars;
     protected Map<String, Function> functions;
     protected Map<String, Function> functionAlias;
-    protected List<Script> scripts;
+//    protected List<Script> scripts;
 
     public AbstractSymbolTable() {
         this(null);
@@ -61,7 +58,7 @@
         this.vars = null;
         this.functions = null;
         this.functionAlias = null;
-        this.scripts = null;
+//        this.scripts = null;
     }
 
     @Override
@@ -127,13 +124,13 @@
         return this.functionAlias;
     }
 
-    protected List<Script> getScripts() {
-        if (this.scripts == null) {
-            this.scripts = new ArrayList<>();
-        }
-        return this.scripts;
-    }
-
+//    protected List<Script> getScripts() {
+//        if (this.scripts == null) {
+//            this.scripts = new ArrayList<>();
+//        }
+//        return this.scripts;
+//    }
+//
     @Override
     public boolean exists(String name) {
         if (StringUtils.isEmpty(name)) {
@@ -191,16 +188,16 @@
         for (SymbolTable other : this.symbolTables) {
             Function fn = other.function(name);
             if (fn != null) {
-                if (fn instanceof ScriptFunction) {
-                    continue;
-                }
+//                if (fn instanceof ScriptFunction) {
+//                    continue;
+//                }
                 return fn;
             }
         }
-        if (this.scripts == null || this.scripts.isEmpty()) {
-            return null;
-        }
-        return new ScriptFunction(name);
+//        if (this.scripts != null && ! this.scripts.isEmpty()) {
+//            return new ScriptFunction(name);
+//        }
+        return null;
     }
 
     @Override
@@ -241,19 +238,19 @@
         return Collections.unmodifiableCollection(this.vars.keySet());
     }
 
+//    @Override
+//    public Collection<Script> scripts() {
+//        Set<Script> theScripts = new HashSet<>();
+//        for (SymbolTable symbolTable : this.symbolTables) {
+//            theScripts.addAll(symbolTable.scripts());
+//        }
+//        if (this.scripts != null) {
+//            theScripts.addAll(this.scripts);
+//        }
+//        return Collections.unmodifiableCollection(theScripts);
+//    }
+//
     @Override
-    public Collection<Script> scripts() {
-        Set<Script> theScripts = new HashSet<>();
-        for (SymbolTable symbolTable : this.symbolTables) {
-            theScripts.addAll(symbolTable.scripts());
-        }
-        if (this.scripts != null) {
-            theScripts.addAll(this.scripts);
-        }
-        return Collections.unmodifiableCollection(theScripts);
-    }
-
-    @Override
     public Iterator<Function> iterator() {
         return this.functions().iterator();
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/SymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/SymbolTable.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/SymbolTable.java	(revision 44533)
@@ -3,7 +3,6 @@
 import java.util.Collection;
 
 import org.gvsig.tools.lang.Cloneable;
-import org.gvsig.tools.script.Script;
 
 public interface SymbolTable extends Iterable<Function>, Cloneable {
 
@@ -31,7 +30,7 @@
     
     public Collection<Function> localfunctions();
 
-    public Collection<Script> scripts();
+//    public Collection<Script> scripts();
 
     @Override
     public SymbolTable clone() throws CloneNotSupportedException;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionEvaluatorManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionEvaluatorManager.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionEvaluatorManager.java	(revision 44533)
@@ -2,10 +2,9 @@
 package org.gvsig.expressionevaluator;
 
 import java.util.Collection;
-import org.apache.commons.lang3.ArrayUtils;
-import org.apache.commons.lang3.StringUtils;
 import org.gvsig.tools.bookmarksandhistory.Bookmarks;
 import org.gvsig.tools.bookmarksandhistory.History;
+import org.gvsig.tools.resourcesstorage.ResourcesStorage;
 import org.gvsig.tools.script.ScriptManager;
 
 
@@ -66,4 +65,9 @@
     public Bookmarks<Expression> getBookmarks();
     
     public History<Expression> getHistory();
+    
+    public ResourcesStorage getScriptsResourcesStorage();
+
+    public void setScriptsResourcesStorage(ResourcesStorage scriptsResourcesStorage);
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarCompiler.java	(revision 44533)
@@ -126,7 +126,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("IFF((\"V1\" = 11), LET('V2', 22))", code.toString());
+        assertEquals("IFF((\"V1\" = 11), LET('V2', 22), NULL)", code.toString());
     }
 
     public void testIfThenElse() {
@@ -144,7 +144,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("IFF((\"V1\" = 11), BLOCK(LET('V2', 22), LET('V1', 10)))", code.toString());
+        assertEquals("IFF((\"V1\" = 11), BLOCK(LET('V2', 22), LET('V1', 10)), NULL)", code.toString());
     }
 
     public void testWhile() {
@@ -243,7 +243,7 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CASE(((\"Field_1\" >= 75) AND (\"Field_1\" <= 79)), ((\"Field_1\" >= 80) AND (\"Field_1\" <= 84)), 100, 110)", code.toString());
+        assertEquals("CASE(((\"Field_1\" >= 75) AND (\"Field_1\" <= 79)), ((\"Field_1\" >= 80) AND (\"Field_1\" <= 84)), 100, 110, NULL)", code.toString());
     }
     
     public void testCase3() {
@@ -256,32 +256,41 @@
     }
     
     public void testDef1() {
-        String source = "CREATE PROCEDURE test1 AS print('Hola'); END PROCEDURE"; 
+        String source = "CREATE PROCEDURE test1 AS BEGIN print('Hola'); END PROCEDURE"; 
 
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', print('Hola'))", code.toString());
+        assertEquals("CREATE_FUNCTION('test1', NULL, print('Hola'), NULL, NULL, NULL)", code.toString());
     }
     
     public void testDef2() {
-        String source = "CREATE PROCEDURE test1 nombre AS print('Hola '+nombre); END PROCEDURE";
+        String source = "CREATE PROCEDURE test1 nombre AS BEGIN print('Hola '+nombre); END PROCEDURE";
 
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), print(('Hola ' + \"nombre\")))", code.toString());
+        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), print(('Hola ' + \"nombre\")), NULL, NULL, NULL)", code.toString());
     }
 
     public void testDef3() {
-        String source = "CREATE PROCEDURE test1 nombre AS RETURN 'Hola '||nombre; END PROCEDURE";
+        String source = "CREATE PROCEDURE test1 nombre AS BEGIN RETURN 'Hola '||nombre; END PROCEDURE";
 
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), RETURN(('Hola ' || \"nombre\")))", code.toString());
+        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), RETURN(('Hola ' || \"nombre\")), NULL, NULL, NULL)", code.toString());
     }
+    
+    public void testCreateFunctionExtern1() {
+        String source = "CREATE FUNCTION test1(nombre) AS 'addons/test/test', test1";
 
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source);
+        assertEquals("CREATE_FUNCTION('test1', LIST('nombre'), NULL, 'addons/test/test', 'test1', NULL)", code.toString());
+    }
+    
     public void testList() {
         String source = "set x TO LIST('hola','adios','fin')";
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarInterpreter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarInterpreter.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestGrammarInterpreter.java	(revision 44533)
@@ -294,7 +294,7 @@
         Compiler compiler = createCompiler();
         Interpreter interpreter = createInterpreter(symbolTable);
 
-        String source = "CREATE PROCEDURE test1 AS RETURN 'Hola'; END PROCEDURE"; 
+        String source = "CREATE PROCEDURE test1 AS BEGIN RETURN 'Hola'; END PROCEDURE"; 
         Code code = compiler.compileExpression(source);
         Object v = interpreter.run(code);
 
@@ -310,7 +310,7 @@
         Compiler compiler = createCompiler();
         Interpreter interpreter = createInterpreter(symbolTable);
 
-        String source = "CREATE PROCEDURE test1 nombre AS RETURN 'Hola ' || nombre; END PROCEDURE";
+        String source = "CREATE PROCEDURE test1 nombre AS BEGIN RETURN 'Hola ' || nombre; END PROCEDURE";
         Code code = compiler.compileExpression(source);
         Object v = interpreter.run(code);
 
@@ -326,7 +326,7 @@
         Compiler compiler = createCompiler();
         Interpreter interpreter = createInterpreter(symbolTable);
 
-        String source = "CREATE PROCEDURE test1 nombre AS RETURN 'Hola ' || nombre; END PROCEDURE";
+        String source = "CREATE PROCEDURE test1 nombre AS BEGIN RETURN 'Hola ' || nombre; END PROCEDURE";
         Code code = compiler.compileExpression(source);
         Object v = interpreter.run(code);
 
@@ -342,7 +342,7 @@
         Compiler compiler = createCompiler();
         Interpreter interpreter = createInterpreter(symbolTable);
 
-        String source = "CREATE PROCEDURE test1 nombre AS RETURN 'Hola ' || nombre; END PROCEDURE";
+        String source = "CREATE PROCEDURE test1 nombre AS BEGIN RETURN 'Hola ' || nombre; END PROCEDURE";
         Code code = compiler.compileExpression(source);
         Object v = interpreter.run(code);
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestSymbolTable.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestSymbolTable.java	(revision 44533)
@@ -52,7 +52,7 @@
 
         assertEquals(0, symbolTable.variables().size());
         assertEquals(0, symbolTable.functions().size());
-        assertEquals(0, symbolTable.scripts().size());
+//        assertEquals(0, symbolTable.scripts().size());
     }
 
     public void testGetter2() {
@@ -65,7 +65,7 @@
         
         assertEquals(0, symbolTable.variables().size());
         assertFalse(symbolTable.functions().isEmpty());
-        assertEquals(0, symbolTable.scripts().size());
+//        assertEquals(0, symbolTable.scripts().size());
     }
 
     public void testSetter1() {
@@ -78,7 +78,7 @@
 
         assertEquals(1, symbolTable.variables().size());
         assertFalse(symbolTable.functions().isEmpty());
-        assertEquals(0, symbolTable.scripts().size());
+//        assertEquals(0, symbolTable.scripts().size());
     }
 
     public void testDelegated1() {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java	(revision 44533)
@@ -166,9 +166,9 @@
         if( fn == null ) {
             return false;
         }
-        if( fn instanceof AbstractSymbolTable.ScriptFunction ) {
-            return false;
-        }
+//        if( fn instanceof AbstractSymbolTable.ScriptFunction ) {
+//            return false;
+//        }
         return true;
     }
     
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44533)
@@ -100,6 +100,35 @@
         }
     }
 
+    public class RuleRequireLiteralString implements Rule {
+
+        private final String id;
+
+        public RuleRequireLiteralString(String id) {
+            this.id = id;
+        }
+
+        @Override
+        public void parse(StatementContext context) {
+            Token token = context.look_token();
+            if (token.getType() != Token.STRING_LITERAL) {
+                throw new ExpressionSyntaxException(
+                        I18N.A_string_literal_was_expected(),
+                        context.getLexicalAnalyzer()
+                );
+            }
+            String identifier = (String) token.getLiteral();
+            Code code = context.getCodeBuilder().constant(identifier);
+            context.setCode(id, code);
+            context.next_token();
+        }
+
+        @Override
+        public String toString() {
+            return "require_literal_string('" + this.id + "')";
+        }
+    }
+
     public class RuleRequireExpression implements Rule {
 
         private final String id;
@@ -180,6 +209,42 @@
         }
     }
 
+    public abstract class AbstractConditionalRule implements ConditionalRule {
+
+        protected final List<Rule> onTrueRules;
+        protected final List<Rule> onFalseRules;
+
+        public AbstractConditionalRule() {
+            this.onTrueRules = new ArrayList<>();
+            this.onFalseRules = new ArrayList<>();
+        }
+
+        protected void parseOnTrueRules(StatementContext context) {
+            for (Rule rule : this.onTrueRules) {
+                rule.parse(context);
+            }
+        }
+
+        protected void parseOnFalseRules(StatementContext context) {
+            for (Rule rule : this.onFalseRules) {
+                rule.parse(context);
+            }
+        }
+
+        @Override
+        public ConditionalRule addRuleOnTrue(Rule rule) {
+            this.onTrueRules.add(rule);
+            return this;
+        }
+
+        @Override
+        public ConditionalRule addRuleOnFalse(Rule rule) {
+            this.onFalseRules.add(rule);
+            return this;
+        }
+
+    }
+
     public class RuleOptionalAnyToken implements ConditionalRule {
 
         private final String[] optional_token;
@@ -275,12 +340,13 @@
         }
     }
 
-    public class RuleOptionalIdentifiers implements Rule {
+    public class RuleOptionalIdentifiers extends AbstractConditionalRule implements ConditionalRule {
 
         private final String id;
         private final String separator;
 
         public RuleOptionalIdentifiers(String id, String separator) {
+            super();
             this.id = id;
             this.separator = separator;
         }
@@ -304,11 +370,13 @@
                 context.next_token();
                 token = context.look_token();
             }
-            Code code = null;
             if (args.size() != 0) {
-                code = context.getCodeBuilder().function(FUNCTION_LIST, args);
+                Code code = context.getCodeBuilder().function(FUNCTION_LIST, args);
+                context.setCode(id, code);
+                this.parseOnTrueRules(context);
+            } else {
+                this.parseOnFalseRules(context);
             }
-            context.setCode(id, code);
         }
 
         @Override
@@ -317,6 +385,35 @@
         }
     }
 
+    public class RuleOptionalLiteralString extends AbstractConditionalRule implements ConditionalRule {
+
+        private final String id;
+
+        public RuleOptionalLiteralString(String id) {
+            super();
+            this.id = id;
+        }
+
+        @Override
+        public void parse(StatementContext context) {
+            Token token = context.look_token();
+            if (token.getType() == Token.STRING_LITERAL) {
+                String s = (String) token.getLiteral();
+                Code code = context.getCodeBuilder().constant(s);
+                context.setCode(id, code);
+                context.next_token();
+                this.parseOnTrueRules(context);
+            } else {
+                this.parseOnFalseRules(context);
+            }
+        }
+
+        @Override
+        public String toString() {
+            return "optional_literal_string('" + id + "')";
+        }
+    }
+
     public static class ArgsBuilderFromNames implements ArgsBuilder {
 
         private final String[] argNames;
@@ -342,9 +439,10 @@
                     }
                 } else {
                     Code code = context.getCode(argName);
-                    if( code != null) {
-                        args.add(code);
+                    if( code == null) {
+                        code = context.getCodeBuilder().constant(null);
                     }
+                    args.add(code);
                 }
             }
             return args;
@@ -447,6 +545,11 @@
     }
 
     @Override
+    public Rule require_literal_string(String id) {
+        return new RuleRequireLiteralString(id);
+    }
+
+    @Override
     public Rule set_expression(String id, Object value) {
         return new RuleSetExpression(id, value);
     }
@@ -467,11 +570,16 @@
     }
 
     @Override
-    public Rule optional_identifiers(String id, String separator) {
+    public ConditionalRule optional_identifiers(String id, String separator) {
         return new RuleOptionalIdentifiers(id, separator);
     }
 
     @Override
+    public ConditionalRule optional_literal_string(String id) {
+        return new RuleOptionalLiteralString(id);
+    }
+
+    @Override
     public CompoundRule repeat_until_any_tokens(String... tokens) {
         return new RuleRepeatUntilAnyTokens(tokens);
     }
